'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

require('regenerator-runtime/runtime');
var bunyan = require('bunyan');

var LoggingDataSource = function () {
  function LoggingDataSource() {
    _classCallCheck(this, LoggingDataSource);
  }

  _createClass(LoggingDataSource, [{
    key: 'initialize',
    value: function initialize(config) {
      var level;
      return regeneratorRuntime.async(function initialize$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return regeneratorRuntime.awrap(config.get('log'));

            case 2:
              if (!_context.sent) {
                _context.next = 7;
                break;
              }

              _context.next = 5;
              return regeneratorRuntime.awrap(config.get('log.level'));

            case 5:
              level = _context.sent;

              this.Logger = {
                create: function create(name) {
                  return bunyan.createLogger({
                    name: name,
                    level: level || 'info',
                    streams: [{
                      stream: process.stdout
                    }]
                  });
                }
              };

            case 7:
            case 'end':
              return _context.stop();
          }
        }
      }, null, this);
    }
  }, {
    key: 'get',
    value: function get(key) {
      return key === 'Logger' ? this.Logger : undefined;
    }
  }]);

  return LoggingDataSource;
}();

module.exports = new LoggingDataSource();
//# sourceMappingURL=Logging.js.map