'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

require('regenerator-runtime/runtime');

var ReplacerDataSource = function () {
  function ReplacerDataSource() {
    _classCallCheck(this, ReplacerDataSource);
  }

  _createClass(ReplacerDataSource, [{
    key: 'initialize',
    value: function initialize(config) {
      var keys, replacement;
      return regeneratorRuntime.async(function initialize$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return regeneratorRuntime.awrap(config.get('security'));

            case 2:
              if (!_context.sent) {
                _context.next = 12;
                break;
              }

              _context.next = 5;
              return regeneratorRuntime.awrap(config.get('security.obfuscate'));

            case 5:
              keys = _context.sent;
              _context.next = 8;
              return regeneratorRuntime.awrap(config.get('security.replacement'));

            case 8:
              replacement = _context.sent;

              if (!(!keys || !replacement)) {
                _context.next = 11;
                break;
              }

              throw Error('You need to fill in both security.obfuscate and security.replacement to use replacer');

            case 11:

              this.replacer = function (key, value) {
                if (keys.includes(key)) {
                  return replacement;
                }
                return value;
              };

            case 12:
            case 'end':
              return _context.stop();
          }
        }
      }, null, this);
    }
  }, {
    key: 'get',
    value: function get(key) {
      return key === 'Replacer' ? this.replacer : null;
    }
  }]);

  return ReplacerDataSource;
}();

module.exports = new ReplacerDataSource();
//# sourceMappingURL=Replacer.js.map