'use strict';

require('regenerator-runtime/runtime');
require('source-map-support').install();
var Common = require('./index');

var bugsnag = void 0;

module.exports = function (handler, appName) {
  return function _callee(event, context) {
    var result;
    return regeneratorRuntime.async(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (bugsnag) {
              _context.next = 4;
              break;
            }

            _context.next = 3;
            return regeneratorRuntime.awrap(require('./utils/bugsnagFactory')(appName));

          case 3:
            bugsnag = _context.sent;

          case 4:
            _context.prev = 4;
            _context.next = 7;
            return regeneratorRuntime.awrap(handler(event, context, Common.async()));

          case 7:
            result = _context.sent;
            return _context.abrupt('return', result);

          case 11:
            _context.prev = 11;
            _context.t0 = _context['catch'](4);

            bugsnag.notify(_context.t0);
            throw _context.t0;

          case 15:
          case 'end':
            return _context.stop();
        }
      }
    }, null, undefined, [[4, 11]]);
  };
};
//# sourceMappingURL=awsHandler.js.map