'use strict';

require('regenerator-runtime/runtime');
require('source-map-support').install();
var Once = require('./Once');
var Common = require('../index').async();
var bugsnag = require('bugsnag');
var uuidv1 = require('uuid/v1');

var initialize = function _callee2(appName) {
  return regeneratorRuntime.async(function _callee2$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          if (!initialize.once) {
            initialize.once = new Once(function _callee() {
              var options, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, x;

              return regeneratorRuntime.async(function _callee$(_context) {
                while (1) {
                  switch (_context.prev = _context.next) {
                    case 0:
                      _context.next = 2;
                      return regeneratorRuntime.awrap(Common.get('stage'));

                    case 2:
                      _context.t0 = _context.sent;
                      _context.t1 = {
                        revision: process.env.BB_COMMIT,
                        errorId: uuidv1()
                      };
                      _context.t2 = ['cvv', 'lastName', 'address1', 'address2', 'address3', 'address4', 'email', 'token', 'city', 'state', 'province', 'zip', 'phone', 'birth_month', 'birth_day', 'birth_year', 'signature', 'accountNumber', 'routingNumber', 'ssn'];
                      options = {
                        releaseStage: _context.t0,
                        sendCode: true,
                        metaData: _context.t1,
                        filters: _context.t2
                      };

                      if (appName) {
                        options.appType = appName;
                      }
                      _iteratorNormalCompletion = true;
                      _didIteratorError = false;
                      _iteratorError = undefined;
                      _context.prev = 10;
                      for (_iterator = process.listeners('uncaughtException')[Symbol.iterator](); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                        x = _step.value;

                        process.removeListener('uncaughtException', x);
                      }
                      _context.next = 18;
                      break;

                    case 14:
                      _context.prev = 14;
                      _context.t3 = _context['catch'](10);
                      _didIteratorError = true;
                      _iteratorError = _context.t3;

                    case 18:
                      _context.prev = 18;
                      _context.prev = 19;

                      if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                      }

                    case 21:
                      _context.prev = 21;

                      if (!_didIteratorError) {
                        _context.next = 24;
                        break;
                      }

                      throw _iteratorError;

                    case 24:
                      return _context.finish(21);

                    case 25:
                      return _context.finish(18);

                    case 26:
                      _context.t4 = bugsnag;
                      _context.next = 29;
                      return regeneratorRuntime.awrap(Common.get('BUGSNAG_LAMBDAS_KEY'));

                    case 29:
                      _context.t5 = _context.sent;
                      _context.t6 = options;

                      _context.t4.register.call(_context.t4, _context.t5, _context.t6);

                      process.on('uncaughtException', function (err) {
                        bugsnag.notify(err);
                      });
                      process.on('unhandledRejection', function (reason, p) {
                        bugsnag.notify(reason);
                      });

                    case 34:
                    case 'end':
                      return _context.stop();
                  }
                }
              }, null, undefined, [[10, 14, 18, 26], [19,, 21, 25]]);
            });
          }
          _context2.next = 3;
          return regeneratorRuntime.awrap(initialize.once.do());

        case 3:
        case 'end':
          return _context2.stop();
      }
    }
  }, null, undefined);
};

module.exports = function _callee3(appName) {
  return regeneratorRuntime.async(function _callee3$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          _context3.next = 2;
          return regeneratorRuntime.awrap(initialize(appName));

        case 2:
          return _context3.abrupt('return', bugsnag);

        case 3:
        case 'end':
          return _context3.stop();
      }
    }
  }, null, undefined);
};
//# sourceMappingURL=bugsnagFactory.js.map