'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

require('regenerator-runtime/runtime');
var Once = require('./utils/Once');

var DataSourceManager = function () {
  function DataSourceManager(dataSource, config) {
    _classCallCheck(this, DataSourceManager);

    if (!dataSource) {
      throw new Error('Cannot construct DataSourceManager with null data source');
    }

    this.dataSource = dataSource;
    this.config = config;
  }

  _createClass(DataSourceManager, [{
    key: '_init',
    value: function _init() {
      var _this = this;

      if (!this.once) {
        this.initializing = true;
        this.once = new Once(function _callee() {
          return regeneratorRuntime.async(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.next = 2;
                  return regeneratorRuntime.awrap(_this.dataSource.initialize(_this.config));

                case 2:
                  _this.initializing = false;

                case 3:
                case 'end':
                  return _context.stop();
              }
            }
          }, null, _this);
        });
      }
      return this.once.do();
    }
  }, {
    key: 'get',
    value: function get(key) {
      return regeneratorRuntime.async(function get$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return regeneratorRuntime.awrap(this._init());

            case 2:
              return _context2.abrupt('return', this.dataSource.get(key));

            case 3:
            case 'end':
              return _context2.stop();
          }
        }
      }, null, this);
    }
  }, {
    key: 'legacy',
    value: function legacy() {
      var _this2 = this;

      return {
        initialize: function initialize() {
          return _this2._init();
        },
        get: function get(key) {
          if (!_this2.once.done) {
            throw new Error('Cannot call legacy().get() before calling legacy().initialize()');
          }
          return _this2.dataSource.get(key);
        }
      };
    }
  }]);

  return DataSourceManager;
}();

module.exports = DataSourceManager;
//# sourceMappingURL=DataSourceManager.js.map