'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

require('regenerator-runtime/runtime');
var _ = require('lodash');

var ClientDataSource = function () {
  function ClientDataSource() {
    _classCallCheck(this, ClientDataSource);
  }

  _createClass(ClientDataSource, [{
    key: 'initialize',
    value: function initialize(config) {
      return regeneratorRuntime.async(function initialize$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              this.clients = {};

              _context.next = 3;
              return regeneratorRuntime.awrap(config.get('pay'));

            case 3:
              if (!_context.sent) {
                _context.next = 19;
                break;
              }

              _context.t0 = require('classy-pay-client');
              _context.next = 7;
              return regeneratorRuntime.awrap(config.get('pay.apiUrl'));

            case 7:
              _context.t1 = _context.sent;
              _context.next = 10;
              return regeneratorRuntime.awrap(config.get('pay.timeout'));

            case 10:
              _context.t2 = _context.sent;
              _context.next = 13;
              return regeneratorRuntime.awrap(config.get('PAY_TOKEN'));

            case 13:
              _context.t3 = _context.sent;
              _context.next = 16;
              return regeneratorRuntime.awrap(config.get('PAY_SECRET'));

            case 16:
              _context.t4 = _context.sent;
              _context.t5 = {
                apiUrl: _context.t1,
                timeout: _context.t2,
                token: _context.t3,
                secret: _context.t4
              };
              this.clients.PayClient = (0, _context.t0)(_context.t5);

            case 19:
              _context.next = 21;
              return regeneratorRuntime.awrap(config.get('api'));

            case 21:
              if (!_context.sent) {
                _context.next = 40;
                break;
              }

              _context.t6 = require('classy-api-client');
              _context.next = 25;
              return regeneratorRuntime.awrap(config.get('APIV2_CLIENT_ID'));

            case 25:
              _context.t7 = _context.sent;
              _context.next = 28;
              return regeneratorRuntime.awrap(config.get('APIV2_CLIENT_SECRET'));

            case 28:
              _context.t8 = _context.sent;
              _context.next = 31;
              return regeneratorRuntime.awrap(config.get('api.timeout'));

            case 31:
              _context.t9 = _context.sent;
              _context.next = 34;
              return regeneratorRuntime.awrap(config.get('api.oauthUrl'));

            case 34:
              _context.t10 = _context.sent;
              _context.next = 37;
              return regeneratorRuntime.awrap(config.get('api.apiUrl'));

            case 37:
              _context.t11 = _context.sent;
              _context.t12 = {
                clientId: _context.t7,
                clientSecret: _context.t8,
                timeout: _context.t9,
                oauthUrl: _context.t10,
                apiUrl: _context.t11
              };
              this.clients.ApiClient = (0, _context.t6)(_context.t12);

            case 40:
            case 'end':
              return _context.stop();
          }
        }
      }, null, this);
    }
  }, {
    key: 'get',
    value: function get(key) {
      return _.get(this.clients, key, null);
    }
  }]);

  return ClientDataSource;
}();

module.exports = new ClientDataSource();
//# sourceMappingURL=Clients.js.map