'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

require('regenerator-runtime/runtime');
var _ = require('lodash');

var EnvironmentDataSource = function () {
  function EnvironmentDataSource() {
    _classCallCheck(this, EnvironmentDataSource);
  }

  _createClass(EnvironmentDataSource, [{
    key: 'initialize',
    value: function initialize() {
      var environments;
      return regeneratorRuntime.async(function initialize$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              this.dir = process.env.LAMBDA_TASK_ROOT || process.env.PWD;
              environments = require(this.dir + '/environment.json');


              if (process.env.STAGE) {
                this.stage = process.env.STAGE;
              } else if (process.env.AWS_LAMBDA_FUNCTION_NAME) {
                this.stage = process.env.AWS_LAMBDA_FUNCTION_NAME.split('-')[2];
              } else {
                this.stage = 'dev';
              }

              this.dryRun = process.env.DRYRUN ? Boolean(process.env.DRYRUN) : false;

              this.environment = environments[this.stage];

            case 5:
            case 'end':
              return _context.stop();
          }
        }
      }, null, this);
    }
  }, {
    key: 'get',
    value: function get(key) {
      switch (key) {
        case 'dir':
          return this.dir;
        case 'stage':
          return this.stage;
        case 'dryRun':
          return this.dryRun;
        default:
          return _.get(this.environment, key, null);
      }
      if (key === 'dir') {
        return this.dir;
      }
    }
  }]);

  return EnvironmentDataSource;
}();

module.exports = new EnvironmentDataSource();
//# sourceMappingURL=Environment.js.map